<?php  
  /* 
    Plugin Name: WP Secure Links 
    Plugin URI: http://sixthlife.net/product/wp-secure-links/ 
    Description: WP Secure Links Plugin can be used to create secure download links. Select the page at <a href="../options-general.php?page=secdown/sdldownload.php">WP Secure Links</a> where user should be redirected for invalid download attempts. 
    Author: Sixthlife
    Version: 1.1 
    Author URI: http://www.sixthlife.net 
    */  
    

include_once(dirname(__FILE__).DIRECTORY_SEPARATOR."sdlfunct.php");                      //including functions.php

add_action('init', 'sdl_download');


function sdl_download(){ 
sdl_startover();                                    // Delete records older that no of days defined in settings file.
if((isset($_GET['dc']))&& (!empty($_GET['dc']))){   // Check if download code is set

    if(sdl_authenticate($_GET['dc'])){                    //Verify if download code is correct.

	$filename = sdl_getfile($_GET['dc']);           
    $fakename = sdl_fakefilename($_GET['dc']);

        if(($filename!= false)&&($fakename!=false&& @fopen($filename,'r')==true)){
     	$file_id = sdl_getfileid($filename);
		$file_notadl = sdl_getfiledlstatus($file_id);
		$extension = sdl_getfileext($file_id);

    	if($extension!=''){
    		$mime = sdl_contenttype($extension);
			}
			else{
			$extension=	sdl_fileexten($filename);
			$mime = sdl_contenttype($extension);
			if($mime==''){
 			$mime = sdl_getContentType($filename);				
			}
			if($extension==''){
			$extension = sdl_fileextenfrommime($mime);	
				}				
			} 
			
      // echo 'start'.$mime.'end'; echo 'start'.$extension.'end'; exit;
       
		 	if($file_notadl==FALSE){ //echo $fakename.'.'.$extension;exit;
	        set_time_limit(0);
	        header('Pragma: public');
	        header('Expires: 0'); 
	        header("Content-Type:".$mime);
	        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	        header('Content-Disposition: attachment;filename='.$fakename.'.'.$extension);
	        header("Content-Transfer-Encoding: binary");
	        header('Connection: Keep-Alive');
	      /*    if (ob_get_length() > 0) {
	 			ob_end_clean();
				}
	        flush();
	        @readfile($filename); */
	        
	        $file = fopen($filename,"rb");
			while(!feof($file))
			{
				print(fread($file, 1024*8));
 				if( ob_get_level() > 0 ) ob_flush();
				flush();
				} 
	        }
	        else{
	        	$mime = ($mime=='application/force-download')?"":$mime;
   		      header("Content-Type:".$mime);
		      header('Content-Disposition: inline;filename='.$fakename.'.'.$extension);  	
		      echo @file_get_contents($filename);
			  exit;	        	
	        }
        }
        else{
    	$error ="<h3>We could not find this file</h3>";} // If the filename or fake filename could not be retrieved. 
        }  
    else{
    	$error =   "<h3>The download link is not correct.</h3>";             // If the download code  is not correct. 
    }
}
else{   
// echo $error. ' '.$filename.' current page: '.currentpageurl(); exit; 	 // If the download code  is not set or empty. 
    }  

if(isset($error)){                              //show no permissions page.  
//echo $error. ' '.$filename.' current page: '.currentpageurl(); exit;
 $no_accesspage = get_option( 'noaccesspage', false );

header('location:'.get_permalink( $no_accesspage ));
exit;	
}

}


function sdl_scripts_general() {
    wp_enqueue_script('secodwn',plugins_url('/js/general.js', __FILE__), array('jquery'));
}
add_action('wp_enqueue_scripts', 'sdl_scripts_general');

/*
	*downloadlink function can be called in themes  
	*@$atts array of param with ex: array('url'=>$url, 
	*'name'=>$name,'id'=>$cssid, 'class'=>$cssclass,
	*'title'=> $titleattr, 'onclick'=>$jsforonclick, 'roles'=>
	*$userrolefileperm, 'users'=>$usersfileperm, 
	*'message'=>$messageforuserswithoughtfileaccess),
	*'extension'=>$extensionoforiginalfile,
    *'notdownload'=>$inlinedisplay,
	*@anchortext the anchor text for the url be generated.
	*return string type hyperlink code
*/

function sdl_downloadlink($atts, $anchortext){

   extract( shortcode_atts( array(
   	  'url' => '',
      'name' => 'download',
      'class' => '',
      'id' => '',
      'title' => '',
      'onclick'=>'',
      'roles'=>'',
      'users'=>'',
      'message'=>'',
      'extension'=>'',
      'notdownload'=>''
      ), $atts ) );
	  
	   if(isset($roles) && $roles!=='' &&  current_user_can('manage_options')==FALSE){
	   		$rolessarray = array();
		     if(strpos($roles, ',')!==FALSE){
	   	 	$roles = str_replace(' ', '',$roles);
	   	 	$rolessarray = explode(',',$roles);
	   	 	}
 		if(!is_user_logged_in () ){
 			return $message;
 		} 
 		else if(count($rolessarray)>0 && in_array(sdl_get_user_role(), $rolessarray)){ 
 			//do nothing
 		}
	   else	if(sdl_get_user_role()!=$roles){return $message;}
	   }

	   if(isset($users) && $users!='' &&  current_user_can('manage_options')==FALSE){
	   	$current_user = wp_get_current_user();
	   	 $current_user->user_login; 
	   	 $usersarray = array();
	   	 if(strpos($users, ',')!==FALSE){
	   	 	$users = str_replace(' ', '',$users);
	   	 	$usersarray = explode(',',$users);
	   	 } //print_r($usersarray);
	   	 if ( !($current_user instanceof WP_User) )
          return $message;
 		if(!is_user_logged_in () ){
 			return $message;
 		} 
 		else if(count($usersarray)>0 && in_array($current_user->user_login, $usersarray)){ 
 			//do nothing
 		}
	   	else if($current_user->user_login!==$users && $users !== 'loggedin'  ){
	   		return $message;
		   }
	   }
	   
	 $pluginpath = plugin_dir_url( 'setreferer.php' ).plugin_basename(__FILE__);
	 $pluginpath = explode('/',$pluginpath );
	 array_pop($pluginpath);
	 $pluginpath = implode('/',$pluginpath);
	 $pluginpath =$pluginpath;
	 if(isset($name) && $name==""){ $name = 'download';}
	 
	 $link = '<a href="'.sdl_downloadurl(trim($url),$name,$notdownload, $extension).'" ';
	 
	 if(isset($id) && $id != ''){ 	 	
	 	$link .= 'id="'.$id.'" ';
	 }
	 if(isset($title) && $title != ''){ 	
	 	$link .= 'title="'.$title.'" ';
	 }	 
	 if(isset($class) && $class != ''){ 	
	 	$link .= 'class="'.$class.'" ';
	 }
	 $postid = get_the_ID();
	 $link .=' onclick="javascript:updateReferer(this,\''.$pluginpath.'\', \''.$postid.'\');" >'.$anchortext.'</a>';
	 
	 if(isset($onclick) && $onclick != ''){ 	
	 	$link = str_replace('" >',$onclick.'" >', $link );
	 }

return $link;	 

}

add_shortcode( 'slink', 'sdl_downloadlink' );

// create custom plugin settings menu
add_action('admin_menu', 'sdl_create_menu');

function sdl_create_menu() {

	//create new top-level menu
	add_options_page('WP Secure Links', 'WP Secure Links', 'administrator', __FILE__, 'sdl_settings_page',plugins_url('/images/icon.png', __FILE__));

	//call register settings function
	add_action( 'admin_init', 'register_sdlsettings' );
}


function register_sdlsettings() {
	//register our settings
	register_setting( 'sdl-settings-group', 'nooffiles' );
	register_setting( 'sdl-settings-group', 'startover' );
	register_setting( 'sdl-settings-group', 'noaccesspage' );

}

function sdl_settings_page() {
$args = array(
    'post_type' => 'page',
	'name' => 'noaccesspage',
	'show_option_none' => 'Select Page',
	'selected' => get_option('noaccesspage')
	);
?><div class="wrap">
<div id="icon-link-manager" class="icon32" ></div>
<h2>WP Secure Links</h2>

<form method="post" action="options.php" ><?php settings_fields( 'sdl-settings-group' ); ?><table class="form-table">
<tbody>     
        <tr valign="top">
		
		<th scope="row"><label for="">Number of Files</th> <td>
        <input type="text" class="regular-text" name="nooffiles" value="<?php if(get_option('nooffiles')==""){ echo 10000;} else{  echo get_option('nooffiles');} ?>" />
        <p class="description">Expected Number of downloadable Files. Default Value is 10,000. </p>
       </td>
         </tr>
		 <tr valign="top">
        <th  scope="row"><label for="">
  Start Over</label></th><td>
        <input type="text" class="regular-text" name="startover" value="<?php if(get_option('startover')==""){ echo 30;} else{  echo get_option('startover');} ?>" />
        <p class="description">Number of days after which unusable data from database is flushed or removed. Default value is 30. </p>
               </td></tr>
      		 <tr valign="top">
        <th  scope="row"><label for="">
   Unauthorized Access Page</label></th><td>
<?php wp_dropdown_pages( $args ); ?> 
        <p class="description">No Permissions page for Unauthorized Access to Downloadable Files.  </p>
               </td></tr>     
</tbody>
</table><?php submit_button(); ?></form>
</div>
<?php } ?><?php 

// Add buttons to html editor
add_action('admin_print_footer_scripts','eg_quicktags');
function eg_quicktags() {
 ?>
<script type="text/javascript" charset="utf-8">
if ( typeof(QTags) == 'function' ) { 
QTags.addButton( 'eg_slink', 'slink', '[slink url=""]', '[/slink]', 'slink', 'Secure Link' );
}

</script>
<?php } ?><?php 
global $sdl_db_version;
$sdl_db_version = "1.1";

function sdl_install(){
global $wpdb;
global $sdl_db_version;	

sdl_createdbtables();
require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
add_option("sdl_db_version", $sdl_db_version);	
}

register_activation_hook(__FILE__, 'sdl_install');

function sdl_on_deactivate() {
global $wpdb;
$sql = "DROP TABLE  {$wpdb->prefix}ddown";
$sql1 = "DROP TABLE  {$wpdb->prefix}ipmap";

require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
$wpdb->query($sql);
$wpdb->query($sql1);

delete_option('noaccesspage');
delete_option('nooffiles');
delete_option('startover');
}
register_deactivation_hook(__FILE__, 'sdl_on_deactivate');
?>